using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
CategoryBuilder.Create(" DEVGRU.", "", ModAPI.LoadSprite("category icon.png"));       




                        

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "HK416 Eotech",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk416icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hk416slide.png", 16f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk416.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders();
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.250f,0.100f);  
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.12f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "HK416 Tan Eotech",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk416ticon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hk416slide.png", 16f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk416t.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders();
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.250f,0.100f);  
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.12f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "HK416 Eotech + Magnifier",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk416micon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hk416slide.png", 16f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk416m.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.250f,0.100f); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.12f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "HK416 Tan Eotech + Magnifier",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/hk416tmicon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/hk416slide.png", 16f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/hk416tm.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.250f,0.100f); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.12f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/hksound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "MP7 Eotech",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp7icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/mp7slide.png", 16f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/mp7.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.450f,0.100f); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.13f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.11f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/mp7sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "MP7 Tan Eotech",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/mp7ticon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var HKSlide = Instance.transform.Find("Slide");
                       HKSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/mp7slide.png", 16f);
                       HKSlide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/mp7t.png", 16f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
                        Instance.FixColliders(); 
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.450f,0.100f); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.86f, 0.13f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.12f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/mp7sound.mp3"),
                        };

                        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "5.56×45";
                        customCartridge.Damage *= 18f;
                        customCartridge.Recoil *= 4f;
                        customCartridge.ImpactForce *= 5f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
		    {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Beretta M9",
                    NameToOrderByOverride = "9A",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m9icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();
						
		       var GlockSlide = Instance.transform.Find("Slide");
                       GlockSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m9slide.png", 14f);

                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m9.png", 14f);
                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.13f, 0.04f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
  
                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/berettasound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                        customCartridge.name = "9mm";
                        customCartridge.Damage *= 9f;
                        customCartridge.Recoil *= 3f;
                        customCartridge.ImpactForce *= 4f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Helmet V1", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/HV1.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Helmet V2", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/HV2.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var childObject = new GameObject("gpnvg18glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/glow31.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Helmet V3", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/HV3.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Helmet V4", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/HV4.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var childObject = new GameObject("digitalpvs31glow");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/glowp31.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Helmet V5", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/HV6.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv6.png", 17f);
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv6.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Belt ", 
                    NameToOrderByOverride = "3",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/belticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/Belt.png", 12); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/Belt.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Vest Variant 1 ", 
                    NameToOrderByOverride = "3",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vesticon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/1vestv1.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/1vestv1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/2vestv1.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Vest Variant 2 ", 
                    NameToOrderByOverride = "3",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/1vestv2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/1vestv2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/2vestv2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Vest Variant 3 ", 
                    NameToOrderByOverride = "3",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/1vestv3.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/1vestv3.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/2vestv3.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Soap"), 
                    NameOverride = "Glow Stick", 
                    NameToOrderByOverride = "9Z",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/glowstickicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/test.png", 17f);
                                                
                        var childObject = new GameObject("glowstick");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(0f, 0f);
                        childObject.transform.localScale = new Vector3(0.05f, 0.06f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("weapon/testglow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");

                        Instance.FixColliders();

                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                    NameOverride = "M61",
                    NameToOrderByOverride = "9Z",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m61icon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/1g.png", 15f);
                        foreach (var c in Instance.GetComponents<Collider2D>())

                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<PolygonCollider2D>(); 
                        if(Instance.GetComponent<PlierBehaviour>() == null)
			{
			    Instance.AddComponent(typeof(PlierBehaviour));
			}
                        var Plier = Instance.GetComponent<PlierBehaviour>();

                        Plier.A = ModAPI.LoadSprite("weapon/1g.png", 15f);
                        Plier.B = ModAPI.LoadSprite("slides/2g.png", 15f);
			{
        		ExplosiveBehaviour expl = Instance.GetComponent(typeof(ExplosiveBehaviour)) as ExplosiveBehaviour;
     		    	 expl.Delay = 4f;
			}
                        
                    }
                }
            );


ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Plier",
                    NameToOrderByOverride = "9Z",
                    DescriptionOverride = "Press F ",
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/pliericon.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/1.png", 15f);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<PolygonCollider2D>(); 
                        if(Instance.GetComponent<PlierBehaviour>() == null)
			{
			    Instance.AddComponent(typeof(PlierBehaviour));
			}
                        var Plier = Instance.GetComponent<PlierBehaviour>();

                        Plier.A = ModAPI.LoadSprite("weapon/1.png", 15f);
                        Plier.B = ModAPI.LoadSprite("weapon/2.png", 15f);
                        
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Tactical GPS ", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/gpsicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/gps.png", 15); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();  
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);          
                        prop.armorPiece = "LowerArm";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/gps.png", 15);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 100;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "Holster", 
                    NameToOrderByOverride = "2",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/holstericon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/test.png", 15); 

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();  
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);          
                        prop.armorPiece = "UpperLegFront";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/test.png", 15);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 1;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Variant 2 (Jacket)",
                    NameToOrderByOverride = "1B",
                    DescriptionOverride = " ", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1j.png"),
                            ModAPI.LoadTexture("Outfit/Variant 2j.png"),
                            ModAPI.LoadTexture("Outfit/Variant 3j.png"),
                            ModAPI.LoadTexture("Outfit/Variant 4j.png"),
                        };
                    }
                }
            );       

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Variant 4 (Jacket+Balaclava)",
                    NameToOrderByOverride = "1D",
                    DescriptionOverride = " ", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/4icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1jb.png"),
                            ModAPI.LoadTexture("Outfit/Variant 2jb.png"),
                            ModAPI.LoadTexture("Outfit/Variant 3jb.png"),
                            ModAPI.LoadTexture("Outfit/Variant 4jb.png"),
                        };
                    }
                }
            );  

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Variant 3 (Balaclava)",
                    NameToOrderByOverride = "1C",
                    DescriptionOverride = " ", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/3icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1nb.png"),
                            ModAPI.LoadTexture("Outfit/Variant 2nb.png"),
                            ModAPI.LoadTexture("Outfit/Variant 3nb.png"),
                            ModAPI.LoadTexture("Outfit/Variant 4nb.png"),
                        };
                    }
                }
            );               

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "Variant 1",
                    NameToOrderByOverride = "1A",
                    DescriptionOverride = " ", 
                    CategoryOverride = ModAPI.FindCategory(" DEVGRU."), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1n.png"),
                            ModAPI.LoadTexture("Outfit/Variant 2n.png"),
                            ModAPI.LoadTexture("Outfit/Variant 3n.png"),
                            ModAPI.LoadTexture("Outfit/Variant 4n.png"),
                        };
                    }
                }
            );          






        }









public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
